(function () {
    "use strict";

    return {
        initialize: function () {

            this.validateCCAuth();
            jQuery(this.$container).find("#lblMsg").hide();
        },
        validateCCAuth: function () {
            var ccAPI = "{{iparam.api_key}}";
            var ccUName = "{{iparam.cc_username}}";
            _self = this;
            jQuery.ajax({
                url: 'https://api.getcloudcherry.com/api/LoginToken',
                type: 'POST',
                data: { username: ccUName, password: ccAPI, grant_type: 'password' },
                success: function (data, textStatus, xhr) {
                    if (xhr.status != 200) {
                        _self.handleError(false);
                    }
                    else if (xhr.status == 200) {
                        _self.displayNPSnFreeTextByRole();
                    }
                },
                error: function () {
                    _self.handleError(false);
                }
            });

        },
        displayNPSnFreeTextByRole: function () {
            //Fetch the current fresh desk domain name 
            var currentDomainName = domHelper.getDomainName();
            //Identifying the logged in role and current page [contact or ticket]
            jQuery.ajax({
                url: 'https://' + currentDomainName + '/api/v2/agents/me',
                type: 'Get',
                success: function (data, textStatus, xhr) {
                    if (xhr.status == 200) {
                        jQuery.ajax({
                            url: 'https://' + currentDomainName + '/api/v2/roles/' + data.role_ids[0],
                            type: 'Get',
                            headers: { "Authorization": "Basic " + btoa("{{iparam.fd_APIKey}}:X") },
                            success: function (data, textStatus, xhr) {
                                if (xhr.status == 200) {
                                    var pageType = page_type;
                                    var currentRoleType = data.name;
                                    _self.getNPSnFreeText(currentRoleType, pageType, currentDomainName);
                                }
                            },
                            error: function (data) {
                                console.log(data);
                            }
                        });
                    }
                }
            });
        },
        getNPSnFreeText: function (role, pageType, currentDomainName) {
            var _request = this.$request;
            if (role == "Agent") {
                //If the role is Agent then displays the NPS Score of the current ticket
                if (pageType == 'ticket') {
                    console.log(domHelper.ticket);
                    domHelper.ticket.onTicketPropertiesUpdated(this.ticketPropertiesUpdated.bind(this.ticketPropertiesUpdated.bind(this), _request));
                    var arrFields = domHelper.ticket.getTicketInfo().helpdesk_ticket.custom_field;
                    var keyOfFields = Object.keys(arrFields);
                    var keyName = keyOfFields[0];
                    var indexOfLastUSCore = keyName.lastIndexOf("_");
                    var uId = keyName.substring(indexOfLastUSCore, keyName.lengh);
                    var fieldName = "npsscore" + uId;
                    jQuery(_self.$container).find("#apptext").html('NPS SCORE : <span>' + arrFields[fieldName] + '</span>');
                    jQuery(_self.$container).find("#loading").hide();
                }
                else if (pageType == 'contact') {
                    var contactId = domHelper.contact.getContactInfo().user.id;
                    jQuery.ajax({
                        url: 'https://' + currentDomainName + '/api/v2/tickets?requester_id=' + contactId,
                        type: 'Get',
                        headers: { "Authorization": "Basic " + btoa("{{iparam.fd_APIKey}}:X") },
                        success: function (data, textStatus, xhr) {
                            if (xhr.status == 200) {

                                var tblRows = '';
                                for (var dataRows = 0; dataRows < data.length; dataRows++) {
                                    var objTicket = data[dataRows];
                                    //var month = parseInt(new Date(objTicket.created_at).getMonth()) + parseInt(1);
                                    var npsScore = objTicket.custom_fields.npsscore == null ? "-" : objTicket.custom_fields.npsscore;
                                    var freeText = objTicket.custom_fields.freetext == null ? "Not Found" : objTicket.custom_fields.freetext;
                                    tblRows = tblRows + "<tr><td>" + npsScore + "</td>";
                                    tblRows = tblRows + "<td>" + objTicket.created_at + "</td>";
                                    tblRows = tblRows + "<td>" + freeText + "</td></tr>";
                                }
                                var tblHeaders = '<thead class="prevthead"><tr><th class="prevHistoryth">NPS Score</th><th class="prevHistoryth">Created At</th><th class="prevHistoryth">Free Text</th></tr></thead>';
                                jQuery(_self.$container).find("#apptext").html('<table class="prevHistory">' + tblHeaders + tblRows + '</table>');
                                jQuery(_self.$container).find("#loading").hide();
                            }
                        },
                        error: function (data) {
                            console.log(data);
                        }
                    });
                }
            }
            else {

            }

        },
        handleError: function (flag) {
            if (flag == false) {
                jQuery(this.$container).find("#apptext").html('UserName or API Key is incorrect.');
                jQuery(this.$container).find("#loading").hide();
            }
        },
        ticketPropertiesUpdated: function (_request) {           
            //console.log(domHelper.ticket.getTicketInfo());
            //var email = domHelper.ticket.getTicketInfo().helpdesk_ticket.description;
            console.log(domHelper.ticket.getTicketInfo());
var datax = '{"name":"mahesh"}';
var headers = {"Access-Control-Allow-Origin": "*", "Access-Control-Allow-Headers": "X-Requested-With"};
var options = { headers: headers, body: "Hello world"};
console.log(_request);
_request.post("http://lexicontest.in/api/Note/redirecToLIL/", options).done(function(data){
  console.log(data);
}).fail(function(err){
  console.log(err);
});
            // jQuery.ajax({
            //     url: 'https://lexicontest.in/api/Note/redirecToLIL',
            //     type: 'POST',
            //     data:datax,
            //     contentType: "application/json; charset=utf-8",
            //     //headers: { "Access-Control-Allow-Origin": "*" ,"Access-Control-Allow-Methods": "POST" },
            //     dataType: "json",
            //     success: function (data, textStatus, xhr) {
            //        alert(data); console.log(xhr);
            //     },
            //     fail: function(err) {
            //         console.log(err);
            //     }
            // });
            // code to be executed when the ticket properties are updated.
        }
    };
})();
